#property copyright "Copyright  Craig Harris, PFMC 2009"
#property link      ""

#property indicator_chart_window

double Gda_unused_76[];
double Gda_unused_80[];
double Gda_unused_84[];
extern string eszDescription1 = "<<<<< Horizontal Lines >>>>>";
extern bool ebDrawHorizontalLine = TRUE;
extern int eiHorizontalLinePoint1 = 100;
extern int eiHorizontalLinePoint2 = 80;
extern int eiHorizontalLinePoint3 = 50;
extern int eiHorizontalLinePoint4 = 20;
extern int eiHorizontalLinePoint5 = 0;
extern int eiLineStartIndex = 20;
extern color ecColorLine = Lime;
extern int eiLineSytle = 3;
extern int eiLineWidth = 1;
extern bool ebShowTexts = TRUE;
extern int Text_value_shift_2 = -20;
extern color ecColorText = Lime;
extern int eiTextSize = 10;
extern string eszDescription2 = "<<<<< Horizontal Lines option 2 >>>>>";
extern bool ebDrawHorizontalLine_option2 = FALSE;
extern int eiHorizontalLinePoint1_option2 = 100;
extern int eiHorizontalLinePoint2_option2 = 90;
extern int eiHorizontalLinePoint3_option2 = 80;
extern int eiHorizontalLinePoint4_option2 = 65;
extern int eiHorizontalLinePoint5_option2 = 50;
extern int eiHorizontalLinePoint6_option2 = 35;
extern int eiHorizontalLinePoint7_option2 = 20;
extern int eiHorizontalLinePoint8_option2 = 10;
extern int eiHorizontalLinePoint9_option2 = 0;
extern int eiLineStartIndex_option2 = 20;
extern color ecColorLine_option2 = Lime;
extern int eiLineSytle_option2 = 3;
extern int eiLineWidth_option2 = 1;
extern bool ebShowTexts_option2 = TRUE;
extern int Text_value_shift_2_option2 = -20;
extern color ecColorText_option2 = Lime;
extern int eiTextSize_option2 = 10;
string Gs_dummy_232;
double Gd_240;
bool Gi_unused_256 = TRUE;
int Gi_260;
int Gi_unused_272 = 10;
int Gia_276[20];
int Gi_280;
int Gi_284;
double G_close_288;
double Gd_304;
string Gs_dummy_312;
string Gs_dummy_320;
string Gs_dummy_328;

int init() {
   if (Digits >= 4) {
      Gd_240 = 0.0001;
      Gi_260 = 4;
   } else {
      Gd_240 = 0.01;
      Gi_260 = 2;
   }
   FReInitialize();
   return (0);
}

int deinit() {
   cleanup();
   FReInitialize();
   return (0);
}

int start() {
   if (ebDrawHorizontalLine && (!ebDrawHorizontalLine_option2)) FDrawHorizontalLines();
   if (ebDrawHorizontalLine_option2 && (!ebDrawHorizontalLine)) FDrawHorizontalLines2();
   return (0);
}

void cleanup() {
   string name_0;
   int objs_total_8 = ObjectsTotal();
   for (int Li_12 = objs_total_8 - 1; Li_12 >= 0; Li_12--) {
      name_0 = ObjectName(Li_12);
      if (StringFind(name_0, "GR") == 0) ObjectDelete(name_0);
   }
}

void FDrawHorizontalLines() {
   if (eiLineStartIndex < 1) eiLineStartIndex = 1;
   Gia_276[1] = eiHorizontalLinePoint1;
   Gia_276[2] = eiHorizontalLinePoint2;
   Gia_276[3] = eiHorizontalLinePoint3;
   Gia_276[4] = eiHorizontalLinePoint4;
   Gia_276[5] = eiHorizontalLinePoint5;
   G_close_288 = Close[0];
   Gi_280 = G_close_288 / Gd_240 / 100.0;
   for (Gi_284 = 1; Gi_284 < 6; Gi_284++) {
      Gd_304 = NormalizeDouble((100 * Gi_280 + Gia_276[Gi_284]) * Gd_240, 4);
      FDrawHorizontalLine(StringConcatenate("HorizLine", Gi_284), Gd_304, ecColorLine, eiLineSytle, eiLineWidth, eiLineStartIndex);
      if (ebShowTexts == TRUE) FDrawLabel(StringConcatenate("HorizLabel", Gi_284), DoubleToStr(Gd_304, Gi_260), Gd_304, ecColorText, eiLineStartIndex);
   }
}

void FDrawHorizontalLines2() {
   if (eiLineStartIndex_option2 < 1) eiLineStartIndex_option2 = 1;
   Gia_276[1] = eiHorizontalLinePoint1_option2;
   Gia_276[2] = eiHorizontalLinePoint2_option2;
   Gia_276[3] = eiHorizontalLinePoint3_option2;
   Gia_276[4] = eiHorizontalLinePoint4_option2;
   Gia_276[5] = eiHorizontalLinePoint5_option2;
   Gia_276[6] = eiHorizontalLinePoint6_option2;
   Gia_276[7] = eiHorizontalLinePoint7_option2;
   Gia_276[8] = eiHorizontalLinePoint8_option2;
   Gia_276[9] = eiHorizontalLinePoint9_option2;
   G_close_288 = Close[0];
   Gi_280 = G_close_288 / Gd_240 / 100.0;
   for (Gi_284 = 1; Gi_284 < 10; Gi_284++) {
      Gd_304 = NormalizeDouble((100 * Gi_280 + Gia_276[Gi_284]) * Gd_240, 4);
      FDrawHorizontalLine(StringConcatenate("HorizLine", Gi_284), Gd_304, ecColorLine_option2, eiLineSytle_option2, eiLineWidth_option2, eiLineStartIndex_option2);
      if (ebShowTexts_option2 == TRUE) FDrawLabel2(StringConcatenate("HorizLabel", Gi_284), DoubleToStr(Gd_304, Gi_260), Gd_304, ecColorText_option2, eiLineStartIndex_option2);
   }
}

void FDrawLabel(string A_name_0, string A_text_8, double A_price_16, color A_color_24, int Ai_unused_28) {
   if (ObjectFind(A_name_0) != 0) {
      if (Text_value_shift_2 >= 0) ObjectCreate(A_name_0, OBJ_TEXT, 0, iTime(Symbol(), 0, 0) + 60 * (Text_value_shift_2 * Period()), A_price_16);
      else ObjectCreate(A_name_0, OBJ_TEXT, 0, Time[-Text_value_shift_2], A_price_16);
      ObjectSetText(A_name_0, A_text_8, eiTextSize, "Arial", CLR_NONE);
      ObjectSet(A_name_0, OBJPROP_COLOR, A_color_24);
      return;
   }
   ObjectDelete(A_name_0);
   if (Text_value_shift_2 >= 0) ObjectCreate(A_name_0, OBJ_TEXT, 0, iTime(Symbol(), 0, 0) + 60 * (Text_value_shift_2 * Period()), A_price_16);
   else ObjectCreate(A_name_0, OBJ_TEXT, 0, Time[-Text_value_shift_2], A_price_16);
   ObjectSetText(A_name_0, A_text_8, eiTextSize, "Arial", CLR_NONE);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_24);
}

void FDrawLabel2(string A_name_0, string A_text_8, double A_price_16, color A_color_24, int Ai_unused_28) {
   if (ObjectFind(A_name_0) != 0) {
      if (Text_value_shift_2_option2 >= 0) ObjectCreate(A_name_0, OBJ_TEXT, 0, iTime(Symbol(), 0, 0) + 60 * (Text_value_shift_2_option2 * Period()), A_price_16);
      else ObjectCreate(A_name_0, OBJ_TEXT, 0, Time[-Text_value_shift_2_option2], A_price_16);
      ObjectSetText(A_name_0, A_text_8, eiTextSize_option2, "Arial", CLR_NONE);
      ObjectSet(A_name_0, OBJPROP_COLOR, A_color_24);
      return;
   }
   ObjectDelete(A_name_0);
   if (Text_value_shift_2_option2 >= 0) ObjectCreate(A_name_0, OBJ_TEXT, 0, iTime(Symbol(), 0, 0) + 60 * (Text_value_shift_2_option2 * Period()), A_price_16);
   else ObjectCreate(A_name_0, OBJ_TEXT, 0, Time[-Text_value_shift_2_option2], A_price_16);
   ObjectSetText(A_name_0, A_text_8, eiTextSize_option2, "Arial", CLR_NONE);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_24);
}

void FDrawHorizontalLine(string A_name_0, double A_price_8, color A_color_16, int A_style_20, int A_width_24, int Ai_28) {
   if (ObjectFind(A_name_0) != 0) {
      ObjectCreate(A_name_0, OBJ_TREND, 0, Time[Ai_28], A_price_8, Time[0], A_price_8);
      ObjectSet(A_name_0, OBJPROP_STYLE, A_style_20);
      ObjectSet(A_name_0, OBJPROP_COLOR, A_color_16);
      ObjectSet(A_name_0, OBJPROP_WIDTH, A_width_24);
      return;
   }
   ObjectDelete(A_name_0);
   ObjectCreate(A_name_0, OBJ_TREND, 0, Time[Ai_28], A_price_8, Time[0], A_price_8);
   ObjectSet(A_name_0, OBJPROP_STYLE, A_style_20);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_16);
   ObjectSet(A_name_0, OBJPROP_WIDTH, A_width_24);
}

void FReInitialize() {
   ObjectDelete("HorizLine1");
   ObjectDelete("HorizLine2");
   ObjectDelete("HorizLine3");
   ObjectDelete("HorizLine4");
   ObjectDelete("HorizLine5");
   ObjectDelete("HorizLine6");
   ObjectDelete("HorizLine7");
   ObjectDelete("HorizLine8");
   ObjectDelete("HorizLine9");
   ObjectDelete("HorizLabel1");
   ObjectDelete("HorizLabel2");
   ObjectDelete("HorizLabel3");
   ObjectDelete("HorizLabel4");
   ObjectDelete("HorizLabel5");
   ObjectDelete("HorizLabel6");
   ObjectDelete("HorizLabel7");
   ObjectDelete("HorizLabel8");
   ObjectDelete("HorizLabel9");
}